%define debug_package %{nil}

%define has_java 1
%ifarch %arm aarch64
%define has_java 0
%endif

%define DBPATH %(find /usr/share/sgml/docbook/xml-dtd-4.5*/dbcentx.mod)

# required for desktop file install
%define my_vendor %{_real_vendor}

%define TESTS 0
%define wwwdir /var/www/html/docs

Name:           publican
Version:        4.3.2
Release:        %mkrel 10
Summary:        Common files and scripts for publishing with DocBook XML
Group:          Publishing
# For a breakdown of the licensing, refer to LICENSE
License:        (GPLv2+ or Artistic) and CC0
URL:            https://fedorahosted.org/publican/
Source0:        https://fedorahosted.org/released/publican/Publican-v%{version}.tar.gz
BuildRequires:  gettext-devel
BuildRequires:  perl-devel
# perl module
BuildRequires:  perl(Devel::Cover)
BuildRequires:  perl(Module::Build)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Test::Pod) >= 1.14
BuildRequires:  perl(Test::Pod::Coverage) >= 1.04
BuildRequires:  perl(Archive::Tar) >= 1.84
BuildRequires:  perl(Archive::Zip)
# Not reall required, but sometimes koji pulls in a conflicting dep...
BuildRequires:  perl(Compress::Zlib) >= 2.030
BuildRequires:  perl(Locale::Maketext::Gettext) >= 1.27
BuildRequires:  perl(Carp)
BuildRequires:  perl(Config::Simple)
BuildRequires:  perl(Cwd)
BuildRequires:  perl(DateTime)
BuildRequires:  perl(DateTime::Format::DateParse)
BuildRequires:  perl(DBI)
BuildRequires:  perl(Encode)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Copy::Recursive) >= 0.38
BuildRequires:  perl(File::Find)
BuildRequires:  perl(File::Find::Rule)
BuildRequires:  perl(File::HomeDir)
BuildRequires:  perl(File::Inplace)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::pushd)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(File::Slurp)
BuildRequires:  perl(File::Which)
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(HTML::FormatText)
BuildRequires:  perl(HTML::FormatText::WithLinks)
BuildRequires:  perl(HTML::FormatText::WithLinks::AndTables) >= 0.02
BuildRequires:  perl(HTML::TreeBuilder)
BuildRequires:  perl(HTML::WikiConverter::Markdown) >= 0.06
BuildRequires:  perl(I18N::LangTags::List)
BuildRequires:  perl(IO::String)
BuildRequires:  perl(List::MoreUtils)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(Locale::Language)
BuildRequires:  perl(Locale::PO) >= 0.24
BuildRequires:  perl(Module::Build)
BuildRequires:  perl(Pod::Usage)
BuildRequires:  perl(String::Similarity)
BuildRequires:  perl(Syntax::Highlight::Engine::Kate) >= 0.09
BuildRequires:  perl(Template)
BuildRequires:  perl(Template::Constants)
BuildRequires:  perl(Term::ANSIColor)
BuildRequires:  perl(Text::Wrap)
BuildRequires:  perl(Time::localtime)
BuildRequires:  perl(XML::LibXML) >= 1.70
BuildRequires:  perl(XML::LibXSLT) >= 1.70
BuildRequires:  perl(XML::Simple)
BuildRequires:  perl(XML::TreeBuilder) >= 5.4
# BZ #1053609
BuildRequires:  docbook-style-xsl >= 1.77.1
BuildRequires:  desktop-file-utils
BuildRequires:  gettext
BuildRequires:  perl(Text::CSV_XS)
BuildRequires:  perl(Sort::Versions)
BuildRequires:  perl(DBD::SQLite)
BuildRequires:  docbook5-schemas
BuildRequires:  docbook5-style-xsl >= 1.78.1
BuildRequires:  perl(version) >= 0.77
BuildRequires:  perl(Locale::Msgfmt)
BuildRequires:  perl(Locale::Maketext::Lexicon)
BuildRequires:  perl(Lingua::EN::Fathom)


# Most of these are handled automatically
Requires:       perl(Locale::Maketext::Gettext)  >= 1.27
Requires:       docbook-style-xsl >= 1.77.1
Requires:       perl(XML::LibXML)  >=  1.70
Requires:       perl(XML::LibXSLT) >=  1.70
Requires:       perl(XML::TreeBuilder) >= 5.4
Requires:       perl(HTML::WikiConverter::Markdown) >= 0.06
# BZ #1053609
Requires:       perl-XML-TreeBuilder >= 5.4
Requires:       perl-Template-Toolkit
Requires:       perl(DBD::SQLite)
Requires:       perl(Text::CSV_XS)
Requires:       docbook5-schemas
Requires:       docbook5-style-xsl >= 1.78.1

%if %has_java 
# java
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-io
BuildRequires:  avalon-framework
BuildRequires:  batik
BuildRequires:  fop
BuildRequires:  xmlgraphics-commons
Requires:       fop
Requires:       batik
%endif

# fonts
Requires:       fonts-ttf-chinese
Requires:       fonts-ttf-japanese
Requires:       fonts-ttf-korean
Requires:       fonts-ttf-liberation
Requires:       lklug-fonts
BuildRequires:  fonts-ttf-chinese
BuildRequires:  fonts-ttf-japanese
BuildRequires:  fonts-ttf-korean
BuildRequires:  fonts-ttf-liberation
BuildRequires:  lklug-fonts

%description
Publican is a DocBook publication system, not just a DocBook processing tool.
As well as ensuring your DocBook XML is valid, publican works to ensure
your XML is up to publishable standard.

%package doc
Group:          Publishing
Summary:        Documentation for the Publican package
Requires:       xdg-utils

%description doc
Publican is a tool for publishing material authored in DocBook XML.
This guide explains how to  to create and build books and articles
using publican. It is not a DocBook XML tutorial and concentrates
solely on using the publican tools.

%package releasenotes
Group:          Documentation
Summary:        Release notes for the Publican package
Requires:       xdg-utils

%description releasenotes
Release notes for Publican %{version}.

%package common-web
Group:          Documentation
Summary:        Website style for common brand
Requires:       publican

%description common-web
Website style for common brand.

%package common-db5-web
Group:          Documentation
Summary:        Website style for common brand for DocBook5 content
Requires:       publican

%description common-db5-web
Website style for common brand for DocBook5 content

%prep
%setup -q -n Publican-v%{version}

%build
sed -i -e 's,PATH,%{DBPATH},g' catalog
XML_CATALOG_FILES=$dir/catalog %{__perl} Build.PL installdirs=vendor --nocolours=1

XML_CATALOG_FILES=$dir/catalog ./Build --nocolours=1
dir=`pwd`

cd Users_Guide && XML_CATALOG_FILES=$dir/catalog  %{__perl} -CDAS -I $dir/blib/lib $dir/blib/script/publican build \
    --formats=html-desktop --publish --langs=en-US \
    --common_config="$dir/blib/datadir" \
    --common_content="$dir/blib/datadir/Common_Content" --nocolours

cd $dir

cd Release_Notes && XML_CATALOG_FILES=$dir/catalog %{__perl} -CDAS -I $dir/blib/lib $dir/blib/script/publican build \
    --formats=html-desktop --publish --langs=en-US \
    --common_config="$dir/blib/datadir" \
    --common_content="$dir/blib/datadir/Common_Content" --nocolours

%install
dir=`pwd`

XML_CATALOG_FILES=$dir/catalog ./Build install destdir=%{buildroot} create_packlist=0
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

sed -i -e 's|@@FILE@@|%{_docdir}/%{name}-doc/en-US/index.html|' %{name}.desktop
sed -i -e 's|@@ICON@@|%{_docdir}/%{name}-doc/en-US/images/icon.svg|' %{name}.desktop
sed -i -e 's|@@FILE@@|%{_docdir}/%{name}-releasenotes%{!?_docdir_fmt:-%{version}}/en-US/index.html|' %{name}-releasenotes.desktop
sed -i -e 's|@@ICON@@|%{_docdir}/%{name}-releasenotes%{!?_docdir_fmt:-%{version}}/en-US/images/icon.svg|' %{name}-releasenotes.desktop

sed -i -e 's|Categories=Documentation;X-Red-Hat-Base;|Categories=Development;Documentation;|' %{name}.desktop

desktop-file-install --vendor="%{my_vendor}" --dir=%{buildroot}%{_datadir}/applications %{name}.desktop
desktop-file-install --vendor="%{my_vendor}" --dir=%{buildroot}%{_datadir}/applications %{name}-releasenotes.desktop

%find_lang %{name} --with-man

# Package web common files
mkdir -p -m755 $RPM_BUILD_ROOT/%{wwwdir}/common
dir=`pwd`
cd datadir/Common_Content/common
XML_CATALOG_FILES=$dir/catalog %{__perl} -CDAS -I $dir/blib/lib $dir/blib/script/publican install_brand --web --path=$RPM_BUILD_ROOT/%{wwwdir}/common
cd -
mkdir -p -m755 $RPM_BUILD_ROOT/%{wwwdir}/common-db5
cd datadir/Common_Content/common-db5
XML_CATALOG_FILES=$dir/catalog %{__perl} -CDAS -I $dir/blib/lib $dir/blib/script/publican install_brand --web --path=$RPM_BUILD_ROOT/%{wwwdir}/common-db5
cd -

%check
%if %{TESTS}
dir=`pwd`
XML_CATALOG_FILES=$dir/catalog ./Build --nocolours=1 test
%endif

%files -f %{name}.lang
%doc Changes README COPYING Artistic pod1/publican
%{perl_vendorlib}/Publican.pm
%{perl_vendorlib}/Publican
%{_mandir}/man3/Publican*
%{_mandir}/man1/*
%{_bindir}/publican
%{_bindir}/db5-valid
%{_bindir}/db4-2-db5
%{_datadir}/publican
%config(noreplace) %{_datadir}/publican/default.db
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/publican-website.cfg
%config(noreplace) %{_sysconfdir}/bash_completion.d/_publican

%files doc
%doc Users_Guide/publish/desktop/*
%{_datadir}/applications/%{my_vendor}-%{name}.desktop
%doc fdl.txt

%files releasenotes
%doc Release_Notes/publish/desktop/*
%{_datadir}/applications/%{my_vendor}-%{name}-releasenotes.desktop
%doc fdl.txt

%files common-web
%{wwwdir}/common

%files common-db5-web
%{wwwdir}/common-db5



%changelog
* Sat Jan 16 2021 neoclust <neoclust> 4.3.2-10.mga8
+ Revision: 1672027
- Rebuild on mageia 8
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 4.3.2-8.mga7
+ Revision: 1300400
- Mageia 7 Mass Rebuild

* Sun May 06 2018 wally <wally> 4.3.2-7.mga7
+ Revision: 1226850
- sync .spec with Fedora

* Sun Jun 19 2016 pterjan <pterjan> 4.3.2-3.mga6
+ Revision: 1036359
- Rebuild for perl 5.22.2
+ tv <tv>
- use std macro

* Fri Apr 01 2016 tv <tv> 4.3.2-2.mga6
+ Revision: 997459
- split releasenote package
- package web common files
- drop requires on cvs + gettext
- move font BRs
- sync perl BRs with FC
- drop mips support
- stop manually compiling po files
- kill obsolete BRs

* Fri Apr 01 2016 tv <tv> 4.3.2-1.mga6
+ Revision: 997418
- new release

* Fri Apr 01 2016 tv <tv> 4.3.0-2.mga6
+ Revision: 997389
- BR perl(Locale::Msgfmt) + perl(Locale::Maketext::Lexicon)
- BR perl(Sort::Versions)
- disable debuginfo now it's no more noarch
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild
+ bcornec <bcornec>
- Update to upstream 4.3.0

* Sun Oct 26 2014 danf <danf> 2.8-12.mga5
+ Revision: 793573
- Added user-guide-path.patch to fix building the documentation
+ luigiwalser <luigiwalser>
- add missing BR perl(Date::Parse)
+ umeabot <umeabot>
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild
- Mageia 4 Mass Rebuild
+ dmorgan <dmorgan>
- Fix Buildrequires

* Fri Aug 30 2013 tv <tv> 2.8-9.mga4
+ Revision: 473342
- rebuild for new perl

* Mon Jun 10 2013 tv <tv> 2.8-8.mga4
+ Revision: 441445
- rebuild for new perl

* Sat Apr 13 2013 fwang <fwang> 2.8-7.mga3
+ Revision: 409991
- rebuild for perl 5.16.3

* Sun Mar 10 2013 rtp <rtp> 2.8-6.mga3
+ Revision: 402066
- disable java BR/R on arm/mips

* Sun Jan 13 2013 umeabot <umeabot> 2.8-5.mga3
+ Revision: 378294
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Dec 19 2012 kamil <kamil> 2.8-4.mga3
+ Revision: 332739
- require perl(Locale::PO)

* Thu Nov 29 2012 dmorgan <dmorgan> 2.8-3.mga3
+ Revision: 323212
- Rebuild against new perl

* Sun Jun 24 2012 dmorgan <dmorgan> 2.8-2.mga3
+ Revision: 263069
- Rebuild against new perl

* Sat Dec 31 2011 gil <gil> 2.8-1.mga2
+ Revision: 189203
- update to 2.8

* Thu Nov 03 2011 gil <gil> 2.6-1.mga2
+ Revision: 162456
- update to 2.6
- imported package publican

